%%%-------------------------------------------------------------------
%%% @author 이국현
%%% @copyright (C) <COMPANY>
%%% @doc
%%%
%%% @end
%%%
%%%-------------------------------------------------------------------
-module(mon_users).
-author("이국현").

-include("mon_record.hrl").

%% API
-export([join/2, login/2]).

join(Id, Password) ->
    F = fun() ->
            case mnesia:read(users, Id) of
                [] ->
                    %% 해당 Id로 가입된 데이터가 없으면 저장한다
                    Users = #users{id=Id, password=Password},
                    ok = mnesia:write(Users); %% 가입완료
                _ ->
                    fail %% 가입 실패
            end
        end,
    mnesia:activity(transaction, F).

login(Id, Password) ->
    F = fun() ->
            case mnesia:read(users, Id) of
                [U = #users{password=Password}] ->
                    %% Id, Password 일치, 로그인 성공
                    ok;
                _ ->
                    %% 일치하는 데이터 없음, 로그인 실패
                    fail
            end
        end,
    mnesia:activity(transaction, F).
